package com.sagacloud.extend.dao_data;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.util.compute_engine.core.AnnotationDescription;
import com.sagacloud.util.compute_engine.core.IDao_data;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.DoubleTimeObject;
import com.sagacloud.util.compute_engine.util.DoubleTimeObject_loss_rate;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import org.zillion.util.json.FastJsonUtil;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@AnnotationDescription(value = "dao_data")
public class ImplDao_fjd_0_loss_rate implements IDao_data {

    String database_name;
    String table_name;
    String dao_type = "fjd_0_loss_rate";

    @Override
    public void Initialize(String database_name) {

        this.database_name = database_name;
        this.table_name = "fjd_0_loss_rate";
    }

    @Override
    public String GetName() {
        return this.dao_type;
    }

    @Override
    public List<DoubleTimeObject> GetDataListGteLte(JSONObject dao_key, String time_period, Date time_from, Date time_to, boolean GteLte)
            throws Exception {
        List<DoubleTimeObject> result = null;

        return result;
    }

    @Override
    public void InsertDataListGteLte(JSONObject dao_key, String time_period, List<DoubleTimeObject> outputDataList) throws Exception {
    }

    @Override
    public void DeleteDataListGteLte(JSONObject dao_key, String time_period, Date time_from, Date time_to) throws Exception {
        if (ConstantCE.time_period_seperate_save_two || !ConstantCE.time_period_seperate) {
            this.DeleteDataListGteLte(false, dao_key, time_period, time_from, time_to);
        }
        if (ConstantCE.time_period_seperate_save_two || ConstantCE.time_period_seperate) {
            this.DeleteDataListGteLte(true, dao_key, time_period, time_from, time_to);
        }
    }

    private void DeleteDataListGteLte(boolean time_period_seperate, JSONObject dao_key, String time_period, Date time_from, Date time_to)
            throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        Criteria.put("meter", meter);
        Criteria.put("funcid", funcid);
        if (time_period_seperate) {
            //
        } else {
            Criteria.put("time_period", time_period);
        }
        JSONObject range = new JSONObject();
        range.put("$gte", sdf.format(time_from));
        range.put("$lte", sdf.format(time_to));
        Criteria.put("operate_time", range);
        String table_name_query;
        if (time_period_seperate) {
            table_name_query = table_name + "_" + time_period;
        } else {
            table_name_query = table_name;
        }
        QueryUtil.delete(database_name, table_name_query, Criteria);
    }

    public void InsertDataListGteLte_rate(boolean time_period_seperate, JSONObject dao_key, String time_period,
                                          List<DoubleTimeObject_loss_rate> outputDataList) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");

        JSONArray InsertObjects = new JSONArray();
        for (DoubleTimeObject_loss_rate data : outputDataList) {
            JSONObject InsertObject = new JSONObject();
            InsertObject.put("building", building);
            InsertObject.put("meter", meter);
            InsertObject.put("funcid", funcid);
            if (time_period_seperate) {
                //
            } else {
                InsertObject.put("time_period", time_period);
            }
            InsertObject.put("operate_time", sdf.format(data.operate_time));
            InsertObject.put("valid_count", data.valid_count);
            InsertObject.put("valid_minutes", data.valid_minutes);
            InsertObject.put("valid_rate", data.valid_rate);
            InsertObjects.add(InsertObject);
        }
        String table_name_query;
        if (time_period_seperate) {
            table_name_query = table_name + "_" + time_period;
        } else {
            table_name_query = table_name;
        }
        QueryUtil.batch_insert(database_name, table_name_query, InsertObjects);
    }

    public List<DoubleTimeObject_loss_rate> GetDataListGteLte_rate(JSONObject dao_key, String time_period, Date time_from, Date time_to,
                                                                   boolean GteLte) throws Exception {
        List<DoubleTimeObject_loss_rate> result = null;

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        Criteria.put("meter", meter);
        Criteria.put("funcid", funcid);
        if (ConstantCE.time_period_seperate) {
            //
        } else {
            Criteria.put("time_period", time_period);
        }
        JSONObject range = new JSONObject();
        range.put("$gte", sdf.format(time_from));
        if (GteLte) {
            range.put("$lte", sdf.format(time_to));
        } else {
            range.put("$lt", sdf.format(time_to));
        }
        Criteria.put("operate_time", range);
        String table_name_query;
        if (ConstantCE.time_period_seperate) {
            table_name_query = table_name + "_" + time_period;
        } else {
            table_name_query = table_name;
        }
        JSONArray resultContent = QueryUtil.select(database_name, table_name_query, Criteria);
        List<DoubleTimeObject_loss_rate> dataList = new ArrayList<DoubleTimeObject_loss_rate>();
        for (int ii = 0; ii < resultContent.size(); ii++) {
            JSONObject computelog = (JSONObject) resultContent.get(ii);
            DoubleTimeObject_loss_rate data = new DoubleTimeObject_loss_rate();
            data.operate_time = sdf.parse((String) computelog.get("operate_time"));
            data.valid_count = (Long) computelog.get("valid_count");
            data.valid_minutes = (Long) computelog.get("valid_minutes");
            data.valid_rate = (Double) computelog.get("valid_rate");
            dataList.add(data);
        }
        result = dataList;

        return result;
    }
}
