package com.sagacloud.extend.dao_data;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.util.compute_engine.core.AnnotationDescription;
import com.sagacloud.util.compute_engine.core.IDao_data;
import com.sagacloud.util.compute_engine.util.DoubleTimeObject;
import com.sagacloud.util.compute_engine.util.DoubleTimeObject_fjd_near;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import com.sagacloud.util.compute_engine.util.QueryUtil_fjd;
import org.zillion.util.json.FastJsonUtil;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@AnnotationDescription(value = "dao_data")
public class ImplDao_fjd_near implements IDao_data {

    String database_name;
    String dao_type = "fjd_near";

    @Override
    public void Initialize(String database_name) {

        this.database_name = database_name;
    }

    @Override
    public String GetName() {
        return this.dao_type;
    }

    @Override
    public List<DoubleTimeObject> GetDataListGteLte(JSONObject dao_key, String time_period, Date time_from, Date time_to, boolean GteLte)
            throws Exception {
        List<DoubleTimeObject> result = null;

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");
        result = QueryUtil_fjd.get_fjd_merge(this.database_name, building, meter, funcid, time_period, sdf.format(time_from),
                sdf.format(time_to), GteLte, false);

        return result;
    }

    public List<DoubleTimeObject_fjd_near> GetDataListGteLte_fjd_near(JSONObject dao_key, String time_period, Date time_from, Date time_to,
                                                                      boolean GteLte) throws Exception {
        List<DoubleTimeObject_fjd_near> result = new ArrayList<DoubleTimeObject_fjd_near>();

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");
        List<DoubleTimeObject> dataList = QueryUtil_fjd.get_fjd_merge(this.database_name, building, meter, funcid, time_period,
                sdf.format(time_from), sdf.format(time_to), GteLte, true);
        for (DoubleTimeObject data : dataList) {
            result.add((DoubleTimeObject_fjd_near) data);
        }

        return result;
    }

    @Override
    public void DeleteDataListGteLte(JSONObject dao_key, String time_period, Date time_from, Date time_to) throws Exception {
    }

    @Override
    public void InsertDataListGteLte(JSONObject dao_key, String time_period, List<DoubleTimeObject> outputDataList) throws Exception {
    }

    public void DeleteDataListGteLte_fjd_1(JSONObject dao_key, String time_period, Date time_from, Date time_to) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        Criteria.put("meter", meter);
        Criteria.put("funcid", funcid);
        JSONObject range = new JSONObject();
        range.put("$gte", sdf.format(time_from));
        range.put("$lte", sdf.format(time_to));
        Criteria.put("data_time", range);
        String table_name_query;
        table_name_query = "fjd_1_near" + "_" + time_period;
        QueryUtil.delete(database_name, table_name_query, Criteria);
    }

    public void InsertDataListGteLte_fjd_1(JSONObject dao_key, String time_period, List<DoubleTimeObject_fjd_near> outputDataList) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");

        JSONArray InsertObjects = new JSONArray();
        for (DoubleTimeObject_fjd_near data : outputDataList) {
            JSONObject InsertObject = new JSONObject();
            InsertObject.put("building", building);
            InsertObject.put("meter", meter);
            InsertObject.put("funcid", funcid);
            InsertObject.put("data_time", sdf.format(data.data_time));
            InsertObject.put("data_value", data.data_value);
            InsertObject.put("data_flag", data.data_flag);
            InsertObjects.add(InsertObject);
        }
        String table_name_query;
        table_name_query = "fjd_1_near" + "_" + time_period;
        QueryUtil.batch_insert(database_name, table_name_query, InsertObjects);
    }
}
