package com.sagacloud.extend.dao_data;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.util.compute_engine.core.AnnotationDescription;
import com.sagacloud.util.compute_engine.core.IDao_data;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.DoubleTimeObject;
import com.sagacloud.util.compute_engine.util.DoubleTimeObject_statinst;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import org.zillion.util.json.FastJsonUtil;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@AnnotationDescription(value = "dao_data")
public class ImplDao_fjd_statinst implements IDao_data {

    String database_name;
    String table_name;
    String dao_type = "fjd_statinst";

    @Override
    public void Initialize(String database_name) {

        this.database_name = database_name;
        this.table_name = "fjd_statinst";
    }

    @Override
    public String GetName() {
        return this.dao_type;
    }

    @Override
    public List<DoubleTimeObject> GetDataListGteLte(JSONObject dao_key, String time_period, Date time_from, Date time_to, boolean GteLte)
            throws Exception {
        List<DoubleTimeObject> result = null;

        return result;
    }

    @Override
    public void DeleteDataListGteLte(JSONObject dao_key, String time_period, Date time_from, Date time_to) throws Exception {
    }

    @Override
    public void InsertDataListGteLte(JSONObject dao_key, String time_period, List<DoubleTimeObject> outputDataList) throws Exception {
    }

    public List<DoubleTimeObject_statinst> GetDataListGteLte_statinst(JSONObject dao_key, String time_period, Date time_from, Date time_to,
                                                                      boolean GteLte) throws Exception {
        List<DoubleTimeObject_statinst> result = null;

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        Criteria.put("meter", meter);
        Criteria.put("funcid", funcid);
        if (ConstantCE.time_period_seperate) {
            //
        } else {
            Criteria.put("time_period", time_period);
        }
        JSONObject range = new JSONObject();
        range.put("$gte", sdf.format(time_from));
        if (GteLte) {
            range.put("$lte", sdf.format(time_to));
        } else {
            range.put("$lt", sdf.format(time_to));
        }
        Criteria.put("data_time", range);
        String table_name_query;
        if (ConstantCE.time_period_seperate) {
            table_name_query = table_name + "_" + time_period;
        } else {
            table_name_query = table_name;
        }
        JSONArray resultContent = QueryUtil.select(database_name, table_name_query, Criteria);
        List<DoubleTimeObject_statinst> dataList = new ArrayList<DoubleTimeObject_statinst>();
        for (int ii = 0; ii < resultContent.size(); ii++) {
            JSONObject computelog = (JSONObject) resultContent.get(ii);
            DoubleTimeObject_statinst data = new DoubleTimeObject_statinst();
            data.data_time = sdf.parse((String) computelog.get("data_time"));
            data.data_flag = (Long) computelog.get("data_flag");
            data.data_count = (Long) computelog.get("data_count");
            data.data_avg = (Double) computelog.get("data_avg");
            data.data_max = (Double) computelog.get("data_max");
            data.time_max = (String) computelog.get("time_max");
            data.data_min = (Double) computelog.get("data_min");
            data.time_min = (String) computelog.get("time_min");
            dataList.add(data);
        }
        result = dataList;

        return result;
    }

    public void InsertDataListGteLte_statinst(JSONObject dao_key, String time_period, List<DoubleTimeObject_statinst> outputDataList)
            throws Exception {
        if (ConstantCE.time_period_seperate_save_two || !ConstantCE.time_period_seperate) {
            this.InsertDataListGteLte_statinst(false, dao_key, time_period, outputDataList);
        }
        if (ConstantCE.time_period_seperate_save_two || ConstantCE.time_period_seperate) {
            this.InsertDataListGteLte_statinst(true, dao_key, time_period, outputDataList);
        }
    }

    public void DeleteDataListGteLte_statinst(JSONObject dao_key, String time_period, Date time_from, Date time_to) throws Exception {
        if (ConstantCE.time_period_seperate_save_two || !ConstantCE.time_period_seperate) {
            this.DeleteDataListGteLte_statinst(false, dao_key, time_period, time_from, time_to);
        }
        if (ConstantCE.time_period_seperate_save_two || ConstantCE.time_period_seperate) {
            this.DeleteDataListGteLte_statinst(true, dao_key, time_period, time_from, time_to);
        }
    }

    private void DeleteDataListGteLte_statinst(boolean time_period_seperate, JSONObject dao_key, String time_period, Date time_from, Date time_to)
            throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        Criteria.put("meter", meter);
        Criteria.put("funcid", funcid);
        if (time_period_seperate) {
            //
        } else {
            Criteria.put("time_period", time_period);
        }
        JSONObject range = new JSONObject();
        range.put("$gte", sdf.format(time_from));
        range.put("$lte", sdf.format(time_to));
        Criteria.put("data_time", range);
        String table_name_query;
        if (time_period_seperate) {
            table_name_query = table_name + "_" + time_period;
        } else {
            table_name_query = table_name;
        }
        QueryUtil.delete(database_name, table_name_query, Criteria);
    }

    private void InsertDataListGteLte_statinst(boolean time_period_seperate, JSONObject dao_key, String time_period,
                                               List<DoubleTimeObject_statinst> outputDataList) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");

        JSONArray InsertObjects = new JSONArray();
        for (DoubleTimeObject_statinst data : outputDataList) {
            JSONObject InsertObject = new JSONObject();
            InsertObject.put("building", building);
            InsertObject.put("meter", meter);
            InsertObject.put("funcid", funcid);
            if (time_period_seperate) {
                //
            } else {
                InsertObject.put("time_period", time_period);
            }
            InsertObject.put("data_time", sdf.format(data.data_time));
            InsertObject.put("data_flag", data.data_flag);
            InsertObject.put("data_count", data.data_count);
            InsertObject.put("data_avg", data.data_avg);
            InsertObject.put("data_max", data.data_max);
            InsertObject.put("time_max", data.time_max);
            InsertObject.put("data_min", data.data_min);
            InsertObject.put("time_min", data.time_min);
            InsertObjects.add(InsertObject);
        }
        String table_name_query;
        if (time_period_seperate) {
            table_name_query = table_name + "_" + time_period;
        } else {
            table_name_query = table_name;
        }
        QueryUtil.batch_insert(database_name, table_name_query, InsertObjects);
    }
}
