package com.sagacloud.extend.dao_data;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.util.compute_engine.core.AnnotationDescription;
import com.sagacloud.util.compute_engine.core.IDao_data;
import com.sagacloud.util.compute_engine.util.DoubleTimeObject;
import com.sagacloud.util.compute_engine.util.DoubleTimeObject_reportenergy;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import org.zillion.util.json.FastJsonUtil;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@AnnotationDescription(value = "dao_data")
public class ImplDao_report implements IDao_data {

    String database_name;
    String table_name;
    String dao_type = "report";

    @Override
    public void Initialize(String database_name) {

        this.database_name = database_name;
        this.table_name = "originalreport_data";
    }

    @Override
    public String GetName() {
        return this.dao_type;
    }

    @Override
    public List<DoubleTimeObject> GetDataListGteLte(JSONObject dao_key, String time_period, Date time_from, Date time_to, boolean GteLte)
            throws Exception {
        return null;
    }

    @Override
    public void DeleteDataListGteLte(JSONObject dao_key, String time_period, Date time_from, Date time_to) throws Exception {
    }

    @Override
    public void InsertDataListGteLte(JSONObject dao_key, String time_period, List<DoubleTimeObject> outputDataList) throws Exception {
    }

    public List<DoubleTimeObject_reportenergy> energy_GteLte(JSONObject dao_key, Date time_from, Date time_to, boolean GteLte) throws Exception {
        String data_type = "energy";
        List<DoubleTimeObject_reportenergy> result = null;

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        Criteria.put("meter", meter);
        Criteria.put("funcid", funcid);
        Criteria.put("data_type", data_type);
        JSONObject range = new JSONObject();
        range.put("$gte", sdf.format(time_from));
        if (GteLte) {
            range.put("$lte", sdf.format(time_to));
        } else {
            range.put("$lt", sdf.format(time_to));
        }
        Criteria.put("receivetime", range);
        JSONArray resultContent = QueryUtil.select(database_name, table_name, Criteria);
        List<DoubleTimeObject_reportenergy> dataList = new ArrayList<DoubleTimeObject_reportenergy>();
        for (int ii = 0; ii < resultContent.size(); ii++) {
            JSONObject computelog = (JSONObject) resultContent.get(ii);
            DoubleTimeObject_reportenergy data = new DoubleTimeObject_reportenergy();
            data.time_from = sdf.parse((String) computelog.get("time_from"));
            data.time_to = sdf.parse((String) computelog.get("time_to"));
            data.data = (Double) computelog.get("data");
            dataList.add(data);
        }
        result = dataList;

        return result;
    }

    public List<DoubleTimeObject> read_data_GteLte(JSONObject dao_key, Date time_from, Date time_to, boolean GteLte) throws Exception {
        String data_type = "read_data";
        List<DoubleTimeObject> result = null;

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        Criteria.put("meter", meter);
        Criteria.put("funcid", funcid);
        Criteria.put("data_type", data_type);
        JSONObject range = new JSONObject();
        range.put("$gte", sdf.format(time_from));
        if (GteLte) {
            range.put("$lte", sdf.format(time_to));
        } else {
            range.put("$lt", sdf.format(time_to));
        }
        Criteria.put("receivetime", range);
        JSONArray resultContent = QueryUtil.select(database_name, table_name, Criteria);
        List<DoubleTimeObject> dataList = new ArrayList<DoubleTimeObject>();
        for (int ii = 0; ii < resultContent.size(); ii++) {
            JSONObject computelog = (JSONObject) resultContent.get(ii);
            DoubleTimeObject data = new DoubleTimeObject();
            data.data_time = sdf.parse((String) computelog.get("receivetime"));
            data.data_value = (Double) computelog.get("data");
            dataList.add(data);
        }
        result = dataList;

        return result;
    }

    public DoubleTimeObject read_data_last(JSONObject dao_key, Date time) throws Exception {
        String data_type = "read_data";
        DoubleTimeObject result = null;

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        Criteria.put("meter", meter);
        Criteria.put("funcid", funcid);
        Criteria.put("data_type", data_type);
        JSONObject range = new JSONObject();
        range.put("$lt", sdf.format(time));
        Criteria.put("receivetime", range);
        JSONArray OrderBy = new JSONArray();
        OrderBy.add(QueryUtil.OrderByItem("building", true));
        OrderBy.add(QueryUtil.OrderByItem("meter", true));
        OrderBy.add(QueryUtil.OrderByItem("funcid", true));
        OrderBy.add(QueryUtil.OrderByItem("receivetime", false));
        JSONObject Limit = new JSONObject();
        Limit.put("Skip", 0L);
        Limit.put("Count", 1L);
        JSONArray resultContent = QueryUtil.select(database_name, table_name, Criteria, OrderBy, Limit);
        if (resultContent.size() > 0) {
            JSONObject computelog = (JSONObject) resultContent.get(0);
            result = new DoubleTimeObject();
            result.data_time = sdf.parse((String) computelog.get("receivetime"));
            result.data_value = (Double) computelog.get("data");
        }

        return result;
    }

    public DoubleTimeObject read_data_next(JSONObject dao_key, Date time) throws Exception {
        String data_type = "read_data";
        DoubleTimeObject result = null;

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        String building = (String) dao_key.get("building");
        String meter = (String) dao_key.get("meter");
        long funcid = FastJsonUtil.getLong(dao_key, "funcid");

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        Criteria.put("meter", meter);
        Criteria.put("funcid", funcid);
        Criteria.put("data_type", data_type);
        JSONObject range = new JSONObject();
        range.put("$gt", sdf.format(time));
        Criteria.put("receivetime", range);
        JSONObject Limit = new JSONObject();
        Limit.put("Skip", 0L);
        Limit.put("Count", 1L);
        JSONArray resultContent = QueryUtil.select(database_name, table_name, Criteria, null, Limit);
        if (resultContent.size() > 0) {
            JSONObject computelog = (JSONObject) resultContent.get(0);
            result = new DoubleTimeObject();
            result.data_time = sdf.parse((String) computelog.get("receivetime"));
            result.data_value = (Double) computelog.get("data");
        }

        return result;
    }
}
