package com.sagacloud.init;


import com.sagacloud.repository.HBaseSaveManagerRepository;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class InitRunner implements CommandLineRunner {


    @Value("${zillionHBaseSaveManagerRepository.randomZillionAgent().count:1}")
    private int zillionAgentCount;

    @Override
    public void run(String... args) throws Exception {
        log.warn("----------contextInitialize start--------------");
        try {
            //容器启动时创建HBase的连接，防止其他已经注入到容器中的实例连接HBase时，HBase还没有创建连接 在ServletContext创建时被调用
            HBaseSaveManagerRepository.init(zillionAgentCount);
        } catch (Exception e1) {
            log.error("ControlServiceMain main error", e1);
        }
        log.warn("----------contextInitialize end--------------");
    }

}
