package com.sagacloud.util.compute_engine.fjd;

import com.alibaba.fastjson.JSONObject;
import com.sagacloud.extend.dao_data.ImplDao_fjd_0_loss_rate;
import com.sagacloud.extend.dao_data.ImplDao_fjd_0_rate;
import com.sagacloud.util.compute_engine.core.*;
import com.sagacloud.util.compute_engine.util.*;
import com.sagacloud.util.split.ArrangeUtil;

import java.text.SimpleDateFormat;
import java.util.*;

public class Compute_fjd_0 {
    static int seek_period_count = 2;

    public static Map<String, List<TimeSpan>> Compute(String object_sign, String instance_name, List<CoreInput> inputList,
                                                      List<CoreOutput> outputList, long compute_round, Map<String, List<TimeSpan>> inputTimeSpanMap,
                                                      Map<String, List<TimeSpan>> outputdetailListMap, Date compute_time_from, Date compute_time_to, IDao_log dao_log) throws Exception {
        Map<String, CoreInput> inputMap = new HashMap<String, CoreInput>();
        for (CoreInput input : inputList) {
            inputMap.put(input.input_sign, input);
        }

        // 依次计算每个相关输出
        for (int i = 0; i < outputList.size(); i++) {
            CoreOutput output = outputList.get(i);
            CoreInput input = inputMap.get("ori_" + output.output_sign.substring("fjd_0_".length()));
            if (input.source_output_sign.startsWith("Acc" + "_")) {
                Compute_fjd_0.Compute_Acc_Inst("Acc", object_sign, instance_name, inputMap, output, compute_round, inputTimeSpanMap,
                        outputdetailListMap, dao_log);
            } else if (input.source_output_sign.startsWith("Inst" + "_")) {
                Compute_fjd_0.Compute_Acc_Inst("Inst", object_sign, instance_name, inputMap, output, compute_round, inputTimeSpanMap,
                        outputdetailListMap, dao_log);
            } else if (input.source_output_sign.startsWith("InAc" + "_")) {
                Compute_fjd_0.Compute_InAc(object_sign, instance_name, inputMap, output, compute_round, inputTimeSpanMap, outputdetailListMap,
                        dao_log);
            } else {
                Compute_fjd_0.Compute_EnumV(object_sign, instance_name, inputMap, output, compute_round, inputTimeSpanMap, outputdetailListMap,
                        dao_log);
            }
            if (ConstantCE.fjd_0_loss_rate_enable) {
                String dao_type = "fjd_0_loss_rate";
                ImplDao_fjd_0_loss_rate dao = (ImplDao_fjd_0_loss_rate) Dao_dataManager.Instance().Get(dao_type);

                String time_period = output.time_period;
                long interval = DateUtil.Instance().get_about(time_period);
                List<TimeSpan> timeSpanList = new ArrayList<TimeSpan>();
                if (inputTimeSpanMap.containsKey(input.input_sign)) {
                    timeSpanList.addAll(inputTimeSpanMap.get(input.input_sign));
                }
                {
                    boolean exist = false;
                    for (TimeSpan timeSpan : timeSpanList) {
                        if (timeSpan.timefrom.getTime() <= compute_time_from.getTime() - interval
                                && timeSpan.timeto.getTime() >= compute_time_to.getTime()) {
                            exist = true;
                            break;
                        }
                    }
                    if (!exist) {
                        timeSpanList.add(new TimeSpan(compute_time_from, compute_time_to));
                    }
                }
                {
                    for (TimeSpan timeSpan : timeSpanList) {
                        // timefrom ceiling,timeto floor
                        Date day_ceiling = DateUtil.Instance().get_ceiling(timeSpan.timefrom, "1d");
                        Date day_floor = DateUtil.Instance().get_floor(timeSpan.timeto, "1d");
                        Date month_ceiling = DateUtil.Instance().get_ceiling(timeSpan.timefrom, "1m");
                        Date month_floor = DateUtil.Instance().get_floor(timeSpan.timeto, "1m");
                        Date day_from = DateUtil.Instance().GetDate_offset(day_ceiling, "1d", -1);
                        Date day_to = DateUtil.Instance().GetDate_offset(day_floor, "1d", -1);
                        Date month_from = DateUtil.Instance().GetDate_offset(month_ceiling, "1m", -1);
                        Date month_to = DateUtil.Instance().GetDate_offset(month_floor, "1m", -1);

                        if (day_to.getTime() >= day_from.getTime()) {
                            List<DoubleTimeObject> dataList = Dao_dataManager.Instance().Get(output.dao_type).GetDataListGteLte(output.dao_key,
                                    time_period, day_from, DateUtil.Instance().GetDate_offset(day_to, "1d", 1), false);
                            List<DoubleTimeObject_loss_rate> loss_rateList = new ArrayList<DoubleTimeObject_loss_rate>();
                            int tmp_index = 0;
                            for (Date tmpDate = day_from; tmpDate.compareTo(day_to) <= 0; ) {
                                Date tmpNext = DateUtil.Instance().GetDate_offset(tmpDate, "1d", 1);
                                int tmpCount = 0;
                                for (int index = tmp_index; index < dataList.size(); index++) {
                                    DoubleTimeObject data = dataList.get(index);
                                    tmp_index = index;
                                    if (data.data_time.getTime() >= tmpNext.getTime()) {
                                        break;
                                    }
                                    if (data.data_time.getTime() >= tmpDate.getTime()) {
                                        tmpCount++;
                                    }
                                }
                                DoubleTimeObject_loss_rate loss_rate = new DoubleTimeObject_loss_rate();
                                loss_rate.operate_time = tmpDate;
                                loss_rate.valid_count = tmpCount;
                                loss_rate.valid_minutes = (tmpCount * interval) / (1000L * 60);
                                loss_rate.valid_rate = 1.0 * (loss_rate.valid_minutes * (1000L * 60)) / (tmpNext.getTime() - tmpDate.getTime());
                                loss_rateList.add(loss_rate);

                                tmpDate = tmpNext;
                            }

                            dao.DeleteDataListGteLte(output.dao_key, "1d", day_from, day_to);
                            ConstantCE.SleepBetweenDeleteAndInsert();
                            dao.InsertDataListGteLte_rate(true, output.dao_key, "1d", loss_rateList);
                        } // end if
                        if (month_to.getTime() >= month_from.getTime()) {
                            List<DoubleTimeObject_loss_rate> dataList = dao.GetDataListGteLte_rate(output.dao_key, "1d", month_from,
                                    DateUtil.Instance().GetDate_offset(month_to, "1m", 1), false);
                            List<DoubleTimeObject_loss_rate> loss_rateList = new ArrayList<DoubleTimeObject_loss_rate>();
                            int tmp_index = 0;
                            for (Date tmpDate = month_from; tmpDate.compareTo(month_to) <= 0; ) {
                                Date tmpNext = DateUtil.Instance().GetDate_offset(tmpDate, "1m", 1);
                                long valid_count = 0;
                                long valid_minutes = 0;
                                for (int index = tmp_index; index < dataList.size(); index++) {
                                    DoubleTimeObject_loss_rate data = dataList.get(index);
                                    tmp_index = index;
                                    if (data.operate_time.getTime() >= tmpNext.getTime()) {
                                        break;
                                    }
                                    if (data.operate_time.getTime() >= tmpDate.getTime()) {
                                        valid_count += data.valid_count;
                                        valid_minutes += data.valid_minutes;
                                    }
                                }
                                DoubleTimeObject_loss_rate loss_rate = new DoubleTimeObject_loss_rate();
                                loss_rate.operate_time = tmpDate;
                                loss_rate.valid_count = valid_count;
                                loss_rate.valid_minutes = valid_minutes;
                                loss_rate.valid_rate = 1.0 * (loss_rate.valid_minutes * (1000L * 60)) / (tmpNext.getTime() - tmpDate.getTime());
                                loss_rateList.add(loss_rate);

                                tmpDate = tmpNext;
                            }

                            dao.DeleteDataListGteLte(output.dao_key, "1m", month_from, month_to);
                            ConstantCE.SleepBetweenDeleteAndInsert();
                            dao.InsertDataListGteLte_rate(true, output.dao_key, "1m", loss_rateList);
                        }
                    }
                }
            }
        }

        return inputTimeSpanMap;
    }

    private static void Compute_Acc_Inst(String data_type, String object_sign, String instance_name, Map<String, CoreInput> inputMap,
                                         CoreOutput output, long compute_round, Map<String, List<TimeSpan>> inputTimeSpanMap, Map<String, List<TimeSpan>> outputdetailListMap,
                                         IDao_log dao_log) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

        // 已经计算过
        if (outputdetailListMap.containsKey(output.output_sign)) {
            return;
        }

        int index_ = output.output_sign.lastIndexOf("_");
        String meter = output.output_sign.substring("fjd_0_".length(), index_);
        long funcid = Long.parseLong(output.output_sign.substring(index_ + 1));
        CoreInput input = inputMap.get("ori_" + output.output_sign.substring("fjd_0_".length()));
        String time_period = output.time_period;
        long interval = DateUtil.Instance().get_about(time_period);
        List<TimeSpan> timeSpanList = inputTimeSpanMap.get(input.input_sign);
        // 不需要计算
        if (!inputTimeSpanMap.containsKey(input.input_sign)) {
            return;
        }
        List<TimeSpan> timeSpanListOut = new ArrayList<TimeSpan>();
        List<DoubleTimeObject> outputDataList_all = new ArrayList<DoubleTimeObject>();
        DoubleTimeObject pointLastData = null;
        for (TimeSpan timeSpan : timeSpanList) {
            // 准备数据
            Date timefrom = DateUtil.Instance().GetDate_offset(timeSpan.timefrom, time_period, -1);
            Date timeto = timeSpan.timeto;
            List<DoubleTimeObject> inputDataList = Dao_dataManager.Instance().Get(input.dao_type).GetDataListGteLte(input.dao_key, null,
                    DateUtil.Instance().GetDate_offset(timefrom, time_period, -seek_period_count),
                    DateUtil.Instance().GetDate_offset(timeto, time_period, seek_period_count), true);

            // 计算
            long millisecondsInterval = DateUtil.Instance().get_about(time_period);
            List<DoubleTimeObject> badDataList = new ArrayList<DoubleTimeObject>();
            List<DoubleTimeObject> outputDataList = ArrangeUtil.Instance().ComputeInterval(funcid, data_type, inputDataList, badDataList, timefrom,
                    timeto, millisecondsInterval);
            if (outputDataList.size() > 0) {
                pointLastData = outputDataList.get(outputDataList.size() - 1);
            }

            // 处理badData
            if (badDataList.size() > 0) {
                Dao_dataManager.Instance().Get("ori_flag").InsertDataListGteLte(output.dao_key, time_period, badDataList);
            }

            // 检查上一个数据有无变化
            List<DoubleTimeObject> existDataList = Dao_dataManager.Instance().Get(output.dao_type).GetDataListGteLte(output.dao_key, time_period,
                    timefrom, timefrom, true);
            DoubleTimeObject last_new = null;
            DoubleTimeObject last_old = null;
            if (outputDataList.size() > 0 && outputDataList.get(0).data_time.getTime() == timefrom.getTime()) {
                last_new = outputDataList.get(0);
            }
            if (existDataList.size() == 1) {
                last_old = existDataList.get(0);
            }
            TimeSpan timeSpanOut;
            if ((last_new == null && last_old == null)
                    || (last_new != null && last_old != null && Math.abs(last_new.data_value - last_old.data_value) < 0.001)) {
                timeSpanOut = new TimeSpan(timeSpan.timefrom, timeto);
            } else {
                timeSpanOut = new TimeSpan(timefrom, timeto);
            }
            outputDataList_all.addAll(outputDataList);
            timeSpanListOut.add(timeSpanOut);

            // 删除数据
            Dao_dataManager.Instance().Get(output.dao_type).DeleteDataListGteLte(output.dao_key, time_period, timeSpanOut.timefrom,
                    timeSpanOut.timeto);
            ConstantCE.SleepBetweenDeleteAndInsert();
            // 保存数据
            Dao_dataManager.Instance().Get(output.dao_type).InsertDataListGteLte(output.dao_key, time_period, outputDataList);
        }
        // 统计
        if ("near".equals(output.data_class)) {
            CoreComputeUtil.Stat_near(output.dao_type, output.dao_key, timeSpanListOut, time_period, outputDataList_all);
        }

        for (TimeSpan timeSpan : timeSpanListOut) {
            // 保存日志
            {
                ImplDao_log ImplDao_log = (ImplDao_log) dao_log;
                JSONObject InsertObject = new JSONObject();
                InsertObject.put("building", object_sign);
                InsertObject.put("compute_round", compute_round);
                InsertObject.put("meter", meter);
                InsertObject.put("funcid", funcid);
                InsertObject.put("valid_time_from", sdf.format(timeSpan.timefrom));
                InsertObject.put("valid_time_to", sdf.format(timeSpan.timeto));
                InsertObject.put("operate_time_to", sdf.format(new Date()));
                QueryUtil.insert(ImplDao_log.database_name, "fjd_0_computedetail", InsertObject);

                // fjd_0_metercomputetime
                if (pointLastData != null) {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", object_sign);
                    CriteriaInner.put("meter", meter);
                    CriteriaInner.put("funcid", funcid);
                    JSONObject Set = new JSONObject();
                    Set.put("next_data_time", sdf.format(new Date(pointLastData.data_time.getTime() + interval)));
                    QueryUtil.update(ImplDao_log.database_name, "fjd_0_metercomputetime", CriteriaInner, Set);
                }
            }
        }
    }

    private static void Compute_InAc(String object_sign, String instance_name, Map<String, CoreInput> inputMap, CoreOutput output, long compute_round,
                                     Map<String, List<TimeSpan>> inputTimeSpanMap, Map<String, List<TimeSpan>> outputdetailListMap, IDao_log dao_log) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

        // 已经计算过
        if (outputdetailListMap.containsKey(output.output_sign)) {
            return;
        }

        int index_ = output.output_sign.lastIndexOf("_");
        String meter = output.output_sign.substring("fjd_0_".length(), index_);
        long funcid = Long.parseLong(output.output_sign.substring(index_ + 1));
        CoreInput input = inputMap.get("ori_" + output.output_sign.substring("fjd_0_".length()));
        String time_period = output.time_period;
        long interval = DateUtil.Instance().get_about(time_period);
        List<TimeSpan> timeSpanList = inputTimeSpanMap.get(input.input_sign);
        // 不需要计算
        if (!inputTimeSpanMap.containsKey(input.input_sign)) {
            return;
        }
        List<List<DoubleTimeObject>> inputDataListList = new ArrayList<List<DoubleTimeObject>>();
        for (TimeSpan timeSpan : timeSpanList) {
            // 准备数据
            List<DoubleTimeObject> inputDataList = Dao_dataManager.Instance().Get(input.dao_type).GetDataListGteLte(input.dao_key, null,
                    DateUtil.Instance().GetDate_offset(timeSpan.timefrom, time_period, -2),
                    DateUtil.Instance().GetDate_offset(timeSpan.timeto, time_period, 1), true);
            inputDataListList.add(inputDataList);
        }

        // 计算near
        List<DoubleTimeObject> outputDataList_all = new ArrayList<DoubleTimeObject>();
        for (int i = 0; i < timeSpanList.size(); i++) {
            TimeSpan timeSpan = timeSpanList.get(i);
            List<DoubleTimeObject> inputDataList = inputDataListList.get(i);
            int index_tmp = 0;
            List<DoubleTimeObject> outputDataList = new ArrayList<DoubleTimeObject>();
            Date tmpDate = timeSpan.timefrom;
            while (tmpDate.getTime() <= timeSpan.timeto.getTime()) {
                Date tmpDateNext = DateUtil.Instance().GetDate_offset(tmpDate, time_period, 1);

                int index_before = -1;
                for (int index_data = index_tmp; index_data < inputDataList.size(); index_data++) {
                    DoubleTimeObject data = inputDataList.get(index_data);
                    if (data.data_time.getTime() <= tmpDate.getTime()) {
                        index_before = index_data;
                    } else if (data.data_time.getTime() < tmpDateNext.getTime()) {
                    } else {
                        break;
                    }
                    index_tmp = index_data;
                }

                if (index_before != -1) {
                    DoubleTimeObject data_before = inputDataList.get(index_before);
                    if (tmpDate.getTime() - data_before.data_time.getTime() < interval) {
                        DoubleTimeObject outputData = new DoubleTimeObject();
                        outputData.data_time = tmpDate;
                        outputData.data_value = data_before.data_value;
                        outputDataList.add(outputData);
                    }
                }

                tmpDate = tmpDateNext;
            }
            outputDataList_all.addAll(outputDataList);

            // 删除数据
            Dao_dataManager.Instance().Get(output.dao_type).DeleteDataListGteLte(output.dao_key, time_period, timeSpan.timefrom, timeSpan.timeto);
            ConstantCE.SleepBetweenDeleteAndInsert();
            // 保存数据
            Dao_dataManager.Instance().Get(output.dao_type).InsertDataListGteLte(output.dao_key, time_period, outputDataList);
        }

        for (TimeSpan timeSpan : timeSpanList) {
            // 保存日志
            {
                ImplDao_log ImplDao_log = (ImplDao_log) dao_log;
                JSONObject InsertObject = new JSONObject();
                InsertObject.put("building", object_sign);
                InsertObject.put("compute_round", compute_round);
                InsertObject.put("meter", meter);
                InsertObject.put("funcid", funcid);
                InsertObject.put("valid_time_from", sdf.format(timeSpan.timefrom));
                InsertObject.put("valid_time_to", sdf.format(timeSpan.timeto));
                InsertObject.put("operate_time_to", sdf.format(new Date()));
                QueryUtil.insert(ImplDao_log.database_name, "fjd_0_computedetail", InsertObject);

                // fjd_0_metercomputetime
                TimeSpan timeSpan_last = timeSpanList.get(timeSpanList.size() - 1);
                JSONObject CriteriaInner = new JSONObject();
                CriteriaInner.put("building", object_sign);
                CriteriaInner.put("meter", meter);
                CriteriaInner.put("funcid", funcid);
                JSONObject Set = new JSONObject();
                Set.put("next_data_time", sdf.format(new Date(timeSpan_last.timeto.getTime() + interval)));
                QueryUtil.update(ImplDao_log.database_name, "fjd_0_metercomputetime", CriteriaInner, Set);
            }
        }
    }

    private static void Compute_EnumV(String object_sign, String instance_name, Map<String, CoreInput> inputMap, CoreOutput output,
                                      long compute_round, Map<String, List<TimeSpan>> inputTimeSpanMap, Map<String, List<TimeSpan>> outputdetailListMap, IDao_log dao_log)
            throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

        // 已经计算过
        if (outputdetailListMap.containsKey(output.output_sign)) {
            return;
        }

        int index_ = output.output_sign.lastIndexOf("_");
        String meter = output.output_sign.substring("fjd_0_".length(), index_);
        long funcid = Long.parseLong(output.output_sign.substring(index_ + 1));
        CoreInput input = inputMap.get("ori_" + output.output_sign.substring("fjd_0_".length()));
        String time_period = output.time_period;
        long interval = DateUtil.Instance().get_about(time_period);
        List<TimeSpan> timeSpanList = inputTimeSpanMap.get(input.input_sign);
        // 不需要计算
        if (!inputTimeSpanMap.containsKey(input.input_sign)) {
            return;
        }
        List<List<DoubleTimeObject>> inputDataListList = new ArrayList<List<DoubleTimeObject>>();
        for (TimeSpan timeSpan : timeSpanList) {
            // 准备数据
            List<DoubleTimeObject> inputDataList = Dao_dataManager.Instance().Get(input.dao_type).GetDataListGteLte(input.dao_key, null,
                    DateUtil.Instance().GetDate_offset(timeSpan.timefrom, time_period, -2),
                    DateUtil.Instance().GetDate_offset(timeSpan.timeto, time_period, 1), true);
            inputDataListList.add(inputDataList);
        }

        // 计算near
        List<DoubleTimeObject> outputDataList_all = new ArrayList<DoubleTimeObject>();
        for (int i = 0; i < timeSpanList.size(); i++) {
            TimeSpan timeSpan = timeSpanList.get(i);
            List<DoubleTimeObject> inputDataList = inputDataListList.get(i);
            int index_tmp = 0;
            List<DoubleTimeObject> outputDataList = new ArrayList<DoubleTimeObject>();
            Date tmpDate = timeSpan.timefrom;
            while (tmpDate.getTime() <= timeSpan.timeto.getTime()) {
                Date tmpDateNext = DateUtil.Instance().GetDate_offset(tmpDate, time_period, 1);

                int index_before = -1;
                for (int index_data = index_tmp; index_data < inputDataList.size(); index_data++) {
                    DoubleTimeObject data = inputDataList.get(index_data);
                    if (data.data_time.getTime() <= tmpDate.getTime()) {
                        index_before = index_data;
                    } else if (data.data_time.getTime() < tmpDateNext.getTime()) {
                    } else {
                        break;
                    }
                    index_tmp = index_data;
                }

                if (index_before != -1) {
                    DoubleTimeObject data_before = inputDataList.get(index_before);
                    DoubleTimeObject outputData = new DoubleTimeObject();
                    outputData.data_time = tmpDate;
                    outputData.data_value = data_before.data_value;
                    outputDataList.add(outputData);
                }

                tmpDate = tmpDateNext;
            }
            outputDataList_all.addAll(outputDataList);

            // 删除数据
            Dao_dataManager.Instance().Get(output.dao_type).DeleteDataListGteLte(output.dao_key, time_period, timeSpan.timefrom, timeSpan.timeto);
            ConstantCE.SleepBetweenDeleteAndInsert();
            // 保存数据
            Dao_dataManager.Instance().Get(output.dao_type).InsertDataListGteLte(output.dao_key, time_period, outputDataList);
        }
        // 统计
        if ("near".equals(output.data_class)) {
            CoreComputeUtil.Stat_near(output.dao_type, output.dao_key, timeSpanList, time_period, outputDataList_all);
        }

        // 计算rate
        for (int i = 0; i < timeSpanList.size(); i++) {
            TimeSpan timeSpan = timeSpanList.get(i);
            List<DoubleTimeObject> inputDataList = inputDataListList.get(i);
            Date timeSpan_timefrom_ = DateUtil.Instance().GetDate_offset(timeSpan.timefrom, time_period, -1);
            Date timeSpan_timeto_ = DateUtil.Instance().GetDate_offset(timeSpan.timeto, time_period, -1);
            int index_tmp = 0;
            List<DoubleTimeObject_rate> outputDataList = new ArrayList<DoubleTimeObject_rate>();
            Date tmpDate = timeSpan_timefrom_;
            while (tmpDate.getTime() <= timeSpan_timeto_.getTime()) {
                Date tmpDateNext = DateUtil.Instance().GetDate_offset(tmpDate, time_period, 1);

                int index_before = -1;
                int index_in = -1;
                for (int index_data = index_tmp; index_data < inputDataList.size(); index_data++) {
                    DoubleTimeObject data = inputDataList.get(index_data);
                    if (data.data_time.getTime() <= tmpDate.getTime()) {
                        index_before = index_data;
                    } else if (data.data_time.getTime() < tmpDateNext.getTime()) {
                        index_in = index_data;
                    } else {
                        break;
                    }
                    index_tmp = index_data;
                }

                if (index_before == -1 && index_in == -1) {
                } else if (index_before != -1 && index_in == -1) {
                    DoubleTimeObject data_before = inputDataList.get(index_before);
                    DoubleTimeObject_rate rate = new DoubleTimeObject_rate();
                    rate.data_time = tmpDate;
                    rate.data_flag = 0L;
                    rate.status_value = data_before.data_value;
                    rate.status_ratio = 1.0;
                    outputDataList.add(rate);
                } else {
                    Map<Double, Long> value2millisecond = new HashMap<Double, Long>();
                    if (index_before != -1) {
                        DoubleTimeObject data = inputDataList.get(index_before);
                        if (index_in == -1) {
                            value2millisecond.put(data.data_value, interval);
                        } else {
                            DoubleTimeObject data_in_first = inputDataList.get(index_before + 1);
                            value2millisecond.put(data.data_value, data_in_first.data_time.getTime() - tmpDate.getTime());
                        }
                    }
                    for (int index_data = index_before + 1; index_data <= index_in; index_data++) {
                        DoubleTimeObject data = inputDataList.get(index_data);
                        Date endDate;
                        if (index_data == index_in) {
                            endDate = tmpDateNext;
                        } else {
                            endDate = inputDataList.get(index_data + 1).data_time;
                        }
                        Long mill = endDate.getTime() - data.data_time.getTime();
                        if (value2millisecond.containsKey(data.data_value)) {
                            Long mill_exist = value2millisecond.remove(data.data_value);
                            mill += mill_exist;
                        }
                        value2millisecond.put(data.data_value, mill);
                    }
                    Iterator<Double> iter = value2millisecond.keySet().iterator();
                    while (iter.hasNext()) {
                        Double key = iter.next();
                        Long mill = value2millisecond.get(key);
                        DoubleTimeObject_rate rate = new DoubleTimeObject_rate();
                        rate.data_time = tmpDate;
                        rate.data_flag = 0L;
                        rate.status_value = key;
                        rate.status_ratio = 1.0 * mill / interval;
                        outputDataList.add(rate);
                    }
                }

                tmpDate = tmpDateNext;
            }

            String dao_type = "fjd_0_rate";
            ImplDao_fjd_0_rate dao = (ImplDao_fjd_0_rate) Dao_dataManager.Instance().Get(dao_type);
            // 删除数据
            dao.DeleteDataListGteLte_rate(output.dao_key, time_period, timeSpan.timefrom, timeSpan.timeto);
            ConstantCE.SleepBetweenDeleteAndInsert();
            // 保存数据
            dao.InsertDataListGteLte_rate(output.dao_key, time_period, outputDataList);
        }
        // 统计
        {
            String dao_type = "fjd_0_rate";
            ImplDao_fjd_0_rate dao = (ImplDao_fjd_0_rate) Dao_dataManager.Instance().Get(dao_type);
            Compute_fjd_0.Stat_rate(dao, output.dao_key, timeSpanList, time_period);
        }

        for (TimeSpan timeSpan : timeSpanList) {
            // 保存日志
            {
                ImplDao_log ImplDao_log = (ImplDao_log) dao_log;
                JSONObject InsertObject = new JSONObject();
                InsertObject.put("building", object_sign);
                InsertObject.put("compute_round", compute_round);
                InsertObject.put("meter", meter);
                InsertObject.put("funcid", funcid);
                InsertObject.put("valid_time_from", sdf.format(timeSpan.timefrom));
                InsertObject.put("valid_time_to", sdf.format(timeSpan.timeto));
                InsertObject.put("operate_time_to", sdf.format(new Date()));
                QueryUtil.insert(ImplDao_log.database_name, "fjd_0_computedetail", InsertObject);

                // fjd_0_metercomputetime
                TimeSpan timeSpan_last = timeSpanList.get(timeSpanList.size() - 1);
                JSONObject CriteriaInner = new JSONObject();
                CriteriaInner.put("building", object_sign);
                CriteriaInner.put("meter", meter);
                CriteriaInner.put("funcid", funcid);
                JSONObject Set = new JSONObject();
                Set.put("next_data_time", sdf.format(new Date(timeSpan_last.timeto.getTime() + interval)));
                QueryUtil.update(ImplDao_log.database_name, "fjd_0_metercomputetime", CriteriaInner, Set);
            }
        }
    }

    private static void Stat_rate(ImplDao_fjd_0_rate dao, JSONObject dao_key, List<TimeSpan> timeSpanList, String time_period) throws Exception {
        if (timeSpanList.size() == 0) {
            return;
        }

        long interval = DateUtil.Instance().get_about(time_period);

        List<String> biggerList = Parser_time_period.getBigger(ConstantCE.Stat_time_period_fjd_rate, time_period);
        for (int i = biggerList.size() - 1; i >= 0; i--) {
            String bigger = biggerList.get(i);
            if (bigger.endsWith("min")) {
                biggerList.remove(i);
            }
        }
        List<List<TimeSpan>> biggerTimeSpanList = new ArrayList<List<TimeSpan>>();
        for (String bigger : biggerList) {
            List<TimeSpan> bts = new ArrayList<TimeSpan>();
            DateUtil.Instance().ConvertAndMergeTo(timeSpanList, bigger, "consumption", bts);
            biggerTimeSpanList.add(bts);
        }
        List<TimeSpan> biggestTimeSpanList = biggerTimeSpanList.get(biggerTimeSpanList.size() - 1);
        String biggest = biggerList.get(biggerList.size() - 1);
        Date stat_from = biggestTimeSpanList.get(0).timefrom;
        Date stat_to = DateUtil.Instance().GetDate_offset(biggestTimeSpanList.get(biggestTimeSpanList.size() - 1).timeto, biggest, 1);
        List<DoubleTimeObject_rate> dataList = dao.GetDataListGteLte_rate(dao_key, time_period, stat_from, stat_to, false);
        for (int index = 0; index < biggerList.size(); index++) {
            String bigger = biggerList.get(index);
            long interval_bigger = DateUtil.Instance().get_about(bigger);
            List<TimeSpan> bts = biggerTimeSpanList.get(index);
            for (TimeSpan biggerTimeSpan : bts) {
                List<DoubleTimeObject_rate> outputDataList = new ArrayList<DoubleTimeObject_rate>();
                int tmp_data_index = 0;
                Date tmpDate = biggerTimeSpan.timefrom;
                while (tmpDate.getTime() <= biggerTimeSpan.timeto.getTime()) {
                    Date tmpDateNext = DateUtil.Instance().GetDate_offset(tmpDate, bigger, 1);

                    Map<Double, List<DoubleTimeObject_rate>> valueListMap = new HashMap<Double, List<DoubleTimeObject_rate>>();
                    for (int index_data = tmp_data_index; index_data < dataList.size(); index_data++) {
                        tmp_data_index = index_data;
                        DoubleTimeObject_rate data = dataList.get(index_data);
                        if (data.data_time.getTime() < tmpDate.getTime()) {
                        } else if (data.data_time.getTime() < tmpDateNext.getTime()) {
                            if (!valueListMap.containsKey(data.status_value)) {
                                valueListMap.put(data.status_value, new ArrayList<DoubleTimeObject_rate>());
                            }
                            valueListMap.get(data.status_value).add(data);
                        } else {
                            break;
                        }
                    }
                    Iterator<Double> iter = valueListMap.keySet().iterator();
                    while (iter.hasNext()) {
                        Double key = iter.next();
                        List<DoubleTimeObject_rate> dataListInner = valueListMap.get(key);
                        double millseconds_total = 0.0;
                        for (DoubleTimeObject_rate rate : dataListInner) {
                            millseconds_total += rate.status_ratio * interval;
                        }
                        DoubleTimeObject_rate rate = new DoubleTimeObject_rate();
                        rate.data_time = tmpDate;
                        rate.data_flag = 0L;
                        rate.status_value = key;
                        rate.status_ratio = 1.0 * millseconds_total / interval_bigger;
                        outputDataList.add(rate);
                    }

                    tmpDate = tmpDateNext;
                }
                // 删除数据
                dao.DeleteDataListGteLte_rate(dao_key, bigger, biggerTimeSpan.timefrom, biggerTimeSpan.timeto);
                ConstantCE.SleepBetweenDeleteAndInsert();
                // 保存数据
                dao.InsertDataListGteLte_rate(dao_key, bigger, outputDataList);
            }
        }
    }
}
