package com.sagacloud.util.compute_engine.util;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class QueryUtil_fjd {

    public static List<DoubleTimeObject> get_fjd_merge(String database_name, String building, String meter, long funcid,
                                                       String time_period, String query_time_from, String query_time_to, boolean GteLte, boolean return_fjd_near) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        List<List<DoubleTimeObject>> dataListList = new ArrayList<List<DoubleTimeObject>>();

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        Criteria.put("meter", meter);
        Criteria.put("funcid", funcid);
        if (ConstantCE.time_period_seperate) {
            //
        } else {
            Criteria.put("time_period", time_period);
        }
        JSONObject range = new JSONObject();
        range.put("$gte", query_time_from);
        if (GteLte) {
            range.put("$lte", query_time_to);
        } else {
            range.put("$lt", query_time_to);
        }
        Criteria.put("data_time", range);
        int fjd_count = 4;
        for (int i = 0; i < fjd_count; i++) {
            String table_name_query;
            if (ConstantCE.time_period_seperate) {
                table_name_query = "fjd_" + i + "_near" + "_" + time_period;
            } else {
                table_name_query = "fjd_" + i + "_near";
            }
            JSONArray resultContent = QueryUtil.select(database_name, table_name_query, Criteria);
            List<DoubleTimeObject> dataList = new ArrayList<DoubleTimeObject>();
            for (int ii = 0; ii < resultContent.size(); ii++) {
                JSONObject computelog = (JSONObject) resultContent.get(ii);
                DoubleTimeObject data;
                if (return_fjd_near) {
                    DoubleTimeObject_fjd_near data_fjd_near = new DoubleTimeObject_fjd_near();
                    data_fjd_near.data_flag = (Long) computelog.get("data_flag");
                    data = data_fjd_near;
                } else {
                    data = new DoubleTimeObject();
                }
                data.data_time = sdf.parse((String) computelog.get("data_time"));
                data.data_value = (Double) computelog.get("data_value");
                dataList.add(data);
            }
            dataListList.add(dataList);
        }

        return merge_fjd(dataListList);
    }

    private static List<DoubleTimeObject> merge_fjd(List<List<DoubleTimeObject>> dataListList) {
        List<DoubleTimeObject> result = new ArrayList<DoubleTimeObject>();
        int[] indexs = new int[dataListList.size()];
        while (true) {
            // 寻找时间最小的index
            Date min_time = null;
            List<Integer> indexList = new ArrayList<Integer>();
            for (int i = 0; i < indexs.length; i++) {
                List<DoubleTimeObject> dataList = dataListList.get(i);
                if (indexs[i] >= dataList.size()) {
                    continue;
                }
                DoubleTimeObject data = dataList.get(indexs[i]);
                if (min_time == null) {
                    min_time = data.data_time;
                    indexList.clear();
                    indexList.add(i);
                } else {
                    int cmp = min_time.compareTo(data.data_time);
                    if (cmp > 0) {
                        min_time = data.data_time;
                        indexList.clear();
                        indexList.add(i);
                    } else if (cmp == 0) {
                        indexList.add(i);
                    }
                }
            }
            if (min_time == null) {
                break;
            }

            int index_last = indexList.get(indexList.size() - 1);
            result.add(dataListList.get(index_last).get(indexs[index_last]));

            for (int i : indexList) {
                indexs[i]++;
            }
        }

        return result;
    }
}
